{% apply spaceless %}

  {% set status = 'deferred' %}
  {% set upcoming = [] %}
  {% set already = 0 %}

  {# Special case: No yellow date means immediately yellow. #}
  {% if diffs.green is not null and diffs.yellow is null and diffs.red is not null %}
    {% set diffs = diffs|merge({'yellow':diffs.green}) %}
  {% endif %}

  {% for color in ['green', 'yellow', 'red'] %}
    {# The diff is non-negative if that date has come or passed. #}
    {% if diffs[color] is not null and diffs[color] >= 0 %}
      {% set status = color %}
    {% endif %}
    {% if status == color %}
      {% set upcoming = [] %}
      {% set already = 0 %}
    {% else %}
      {% if diffs[color] is not null %}
        {% set upcoming = upcoming|merge(["+#{-diffs[color] - already}"]) %}
        {% set already = -diffs[color] %}
      {% else %}
        {% set upcoming = upcoming|merge(["+∅"]) %}
      {% endif %}
    {% endif %}
  {% endfor %}

  {# TODO: Consider moving this to partial templates. #}
  {% set d = 'd'|t([], {'context':'Days, abbreviated'}) %}
  {{ attach_library('datedeferfield/formatter') }}
  {% if status == 'deferred' %}
    <span class="datedeferfield-deferred" title="{{labels.deferred}}" aria-label="{{labels.deferred}}">😴</span>
  {% elseif status == 'green' %}
    <span class="datedeferfield-green" title="{{labels.green}}" aria-label="{{labels.green}}">🙂</span>
  {% elseif status == 'yellow' %}
    <span class="datedeferfield-yellow" title="{{labels.yellow}}" aria-label="{{labels.yellow}}">😐</span>
  {% elseif status == 'red' %}
    <span class="datedeferfield-red" title="{{labels.red}}" aria-label="{{labels.red}}">🙁</span>
  {% endif %}
  {% if upcoming %}({{ upcoming|join }}{{ d }}){% endif %}

{% endapply %}
